#!/usr/bin/python
# -*- coding: utf-8 -*-
## \namespace sshareddirclient
import os
import sys
import socket
import urllib
import shutil
import time

from PyQt4 import QtGui
from PyQt4 import QtCore
from PyQt4.QtCore import pyqtSignal
import davclient

from hga.controlgrupos.common.settings import SHARED_COMP
from hga.controlgrupos.common.settings import SHARED_SUB
from hga.controlgrupos.common.settings import VALID_CHARS
import hga.gui.common.icon_rc


##\class SSharedDirClient
# \brief Webdav explorer main class
class SSharedDirClient(QtGui.QWidget):
	triggered = pyqtSignal()
	##\fn __init__(self, parent = None, data = None)
	# \brief Class constructor, create webdav connection and GUI Webdav explorer client
	# \param[in] data: Connection data (ip, port, user, password, nick and group)
	def __init__(self, parent = None, data = None, COMPARTIDA=None, SUBIDAS=None):
		#Creacion de ventana principal compartir
		QtGui.QWidget.__init__(self, parent)

		data['group'] = self.sanitize(data['group'])
		data['nick'] = self.sanitize(data['nick'])
		os.system('sudo /usr/share/cga-crear-carpeta-alumno-profesor/cga-crear-carpeta-alumno-profesor.sh')
		os.system('sudo /usr/share/cga-montar-hgr/cga-montar-hgr.sh '+data['IP'])
		os.system('sudo /usr/share/cga-crear-directorio-hgr-alumno/cga-crear-directorio-hgr-alumno.sh '+data['group']+' '+str(data['nick']).upper())
		os.system('sudo /usr/share/cga-desmontar-hgr/cga-desmontar-hgr.sh')
		os.system('sudo /usr/share/cga-montar-hgr-alumno/cga-montar-hgr-alumno.sh '+data['IP']+' '+data['group']+' '+str(data['nick']).upper())
		self.remotedir = "/ALUMNO"
		self.remotedir2 = "/PROFESOR"
		data["compartida"] = COMPARTIDA
		data["subidas"] = SUBIDAS
		self.setWindowTitle("HGR - Carpeta compartida")
		self.resize(560, 520)
		self.setMinimumSize(560, 520)
		self.upspace = uploadWidget(parent=self)
		self.expwebdav = explorerDAV(parent = self, remotedir2 = self.remotedir2)
		icon = QtGui.QIcon()
		icon.addPixmap(QtGui.QPixmap(":/common/icon/share-blanco.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		self.setWindowIcon(icon)

		#Boton archivos subidos
		vboxmain = QtGui.QVBoxLayout()
		self.setLayout(vboxmain)
		hboxup = QtGui.QHBoxLayout()
		hboxup.addWidget(self.upspace)
		remotelistbutton = QtGui.QPushButton("VER\nARCHIVOS\nCOMPARTIDOS", self)
		self.connect(remotelistbutton, QtCore.SIGNAL("clicked()"), self.mis_archivos_compartidos)
		remotelistbutton.setStyleSheet("background-color: rgb(190, 190, 190); font: bold 14px; color: black; background-position: center")
		remotelistbutton.setMinimumSize(150, 100)
		remotelistbutton.setMaximumSize(250, 100)
		remotelistbutton.setToolTip("Ver archivos subidos")
		hboxup.addWidget(remotelistbutton)

		vboxmain.addLayout(hboxup)
		vboxmain.addWidget(self.expwebdav)

		self.triggered.connect(self.closeEvent)
	
	def closeEvent(self, event):
		os.system('sudo /usr/share/cga-desmontar-hgr/cga-desmontar-hgr.sh')
		os.system('sudo /usr/share/cga-desmontar-hgr-alumno/cga-desmontar-hgr-alumno.sh')
		self.hide()
		
	def mis_archivos_compartidos(self):
		if os.path.exists('/home/usuario/mnt/HGR/'):
			if os.path.exists('/home/usuario/mnt/HGR/ALUMNO'):
				os.system('xdg-open /home/usuario/mnt/HGR/ALUMNO')
			else:
				os.system('mkdir /home/usuario/mnt/HGR/ALUMNO')
				os.system('xdg-open /home/usuario/mnt/HGR/ALUMNO')
		else:
			os.system('mkdir /home/usuario/mnt/HGR/')
			os.system('mkdir /home/usuario/mnt/HGR/ALUMNO')
			os.system('xdg-open /home/usuario/mnt/HGR/ALUMNO')

	def ventanaDialog(self, tipo):
		self.fname = QtGui.QFileDialog(self)
		self.fname.setFileMode(1)
		target = os.environ.get("HOME") + os.path.sep + "Descargas"
		self.fname.setDirectory(target)
		self.fname.setFileMode(QtGui.QFileDialog.AnyFile)
		self.fname.setLabelText(QtGui.QFileDialog.LookIn, "Ruta del sistema")
		self.fname.setLabelText(QtGui.QFileDialog.Reject, "Cancelar")
		self.fname.setLabelText(
			QtGui.QFileDialog.FileType, "Extensiones permitidas"
		)
		self.fname.setLabelText(QtGui.QFileDialog.FileName, "Nombre")

		self.tipoFile(tipo)

	def sanitize(self, data):
		data = data.lstrip()
		data = data.replace(' ', '_')
		for a,b in ( ('á', 'a'), ('é', 'e'), ('í', 'i'), ('ó', 'o'), ('ú', 'u'), ('ñ', 'n'),
					('Á', 'A'), ('É', 'E'), ('Í', 'I'), ('Ó', 'O'), ('Ú', 'U'), ('Ñ', 'N') ):
			data=data.replace(a, b)
		data = str(filter(lambda k: k in VALID_CHARS, data)).lower()
		return data


	##\fn goto_init(self)
	# \brief Go to initial webdav directory
	#Ir al directorio inicial
	def goto_init(self):
		self.filelistupload.current_dir = self.remotedir
		self.filelistupload.level = 6
		self.filelistupload.fill_explorer()

	##\fn up_level(self)
	# \brief Up a one level dir on webdav explorer
	#Subir unn nivel del directorio
	def up_level(self):
		if self.filelistupload.level == 6:
			return
		string = self.filelistupload.current_dir.split('/')
		self.filelistupload.current_dir = ''
		for i in range(1,len(string)-1):
			self.filelistupload.current_dir = self.filelistupload.current_dir + '/' + string[i]
		self.filelistupload.level = self.filelistupload.level - 1
		self.filelistupload.fill_explorer()


##\class uploadWidget
# \brief Upload file widget
class uploadWidget(QtGui.QFrame):
    def __init__(self, parent=None):
        QtGui.QFrame.__init__(self, parent)
        self.remotedir2 = '/home/usuario/mnt/HGR/ALUMNO'
        vbox = QtGui.QVBoxLayout()
        self.setLayout(vbox)
        label = QtGui.QPushButton('PULSAR PARA SELECCIONAR\nLOS ARCHIVOS A COMPARTIR\nCON EL PROFESOR', self)
        self.connect(label, QtCore.SIGNAL('clicked()'), self.exp_archivos_compartidos)
        label.setStyleSheet("background-color: rgb(190, 190, 190); font: bold 14px; color: black; background-position: center;")
        label.setToolTip("Espacio para subir archivos")
        label.setMinimumSize(340, 100)
        vbox.addWidget(label)
 
    def exp_archivos_compartidos(self):
        ruta = self.remotedir2

        self.ventanaDialog(6)
        result = self.fname.exec_()
       
        if result == 1:
            fileComp = str(self.fname.selectedFiles()[0])
            try:
                shutil.copy(fileComp, ruta)
            except Exception as e:
                print "Error relacionado con los permisos de la carpeta (no influye en el correcto funcionamiento):", str(e)
   
    def ventanaDialog(self, tipo):
        self.fname = QtGui.QFileDialog(self)
        self.fname.setFileMode(1)
        target = os.environ.get("HOME") + os.path.sep + "Descargas"
        self.fname.setDirectory(target)
        self.fname.setFileMode(QtGui.QFileDialog.AnyFile)
        self.fname.setLabelText(QtGui.QFileDialog.LookIn, "Ruta del sistema")
        self.fname.setLabelText(QtGui.QFileDialog.Reject, "Cancelar")
        self.fname.setLabelText(
            QtGui.QFileDialog.FileType, "Extensiones permitidas"
        )
        self.fname.setLabelText(QtGui.QFileDialog.FileName, "Nombre")

        self.tipoFile(tipo)
   
    def tipoFile(self, tipo):
        if tipo == 1:
            btnAceptar = "Guardar"
            filtros = "Grupos (*.hgr)"
            tituloVentana = "Exportar grupo"
        elif tipo == 2:
            btnAceptar = "Importar"
            filtros = "Grupos (*.hgr)"
            tituloVentana = "Importar grupo"
        elif tipo == 3:
            btnAceptar = "Guardar"
            filtros = "Texto (*.txt)"
            tituloVentana = "Guardar grupo"
        elif tipo == 4:
            btnAceptar = "Abrir"
            filtros = "Archivos multimedia (*.mp3 *.mp4 *.avi)"
            tituloVentana = "Abrir archivo multimedia"
        elif tipo == 5:
            btnAceptar = "Guardar"
            filtros = "Todos los archivos (*.*)"
            tituloVentana = "Descargar fichero"
        elif tipo == 6:
            btnAceptar = "Compartir"
            filtros = "Todos los archivos (*.*)"
            tituloVentana = "Compartir archivo"

        self.fname.setLabelText(QtGui.QFileDialog.Accept, btnAceptar)
        self.fname.setNameFilter(filtros)
        self.fname.setWindowTitle(tituloVentana)
   
    def _message(self, msg, tipo):
        if tipo == "critical":
            msgBox = QtGui.QMessageBox()
            msgBox.setIcon(QtGui.QMessageBox.Critical)
            msgBox.setText(msg)
            msgBox.setWindowTitle("Error")
            msgBox.setStandardButtons(QtGui.QMessageBox.Ok)
            msgBox.exec_()

	def sanitize(self, data):
		data = data.replace(' ', '_')
		for a,b in ( ('á', 'a'), ('é', 'e'), ('í', 'i'), ('ó', 'o'), ('ú', 'u'), ('ñ', 'n'),
					('Á', 'A'), ('É', 'E'), ('Í', 'I'), ('Ó', 'O'), ('Ú', 'U'), ('Ñ', 'N') ):
			data=data.replace(a, b)
		return data


	##\fn upload_directory(self, path)
	# \brief Metodo encargado de subir directorios y todo su contenido
	def upload_directory(self, path):
		dir = os.path.sep + path.split('/')[-1]
		self.davbackend.creaDirec(self.remotedir + dir)
		for dirName, subdirList, fileList in os.walk(path):

			for subdir in subdirList:
				auxdir = dir + dirName.split(dir)[-1] + os.path.sep + subdir
				self.davbackend.creaDirec(self.remotedir + auxdir)

			auxdir = dir + dirName.split(dir)[-1]

			for file in fileList:
				fich = open(urllib.unquote(dirName + os.path.sep + file), 'r')
				cont = fich.readline()
				if cont == "":
					fich.close()
					continue
				else:
					fich.seek(0, os.SEEK_SET)
					self.davbackend.upload_file(self.remotedir + auxdir + os.path.sep + self.sanitize(file), fich)
				fich.close()


##\class explorerDAV
# \brief Webdabav file browser
class explorerDAV(QtGui.QWidget):
	#Ventana principal compartir
	##\fn __init__(self, parent = None, wdb = None, userdir = None, viewmode = 0)
	# \brief Create gui explorer
	# \param[in] wdb: WebDav connection backend
	# \param[in] userdir: user remote directory (only for viewmode = 1)
	# \param[in] viewmode: webdav client explorer viewmode, 0 is normal mode, 1 is minimal mode(only user remote file list)
	def __init__(self, parent = None, userdir = None, viewmode = 0, remotedir2 = None):
		QtGui.QWidget.__init__(self, parent)
		self.remotedir2 = remotedir2
		self.rutaProfesor = '/home/usuario/mnt/HGR/PROFESOR'
		vboxexp = QtGui.QVBoxLayout()
		self.setLayout(vboxexp)

		if viewmode == 0:
			label = QtGui.QLabel("Archivos compartidos", self)
		else:
			label = QtGui.QLabel("Mis archivos subidos", self)
		label.setStyleSheet("font: bold 14px; color: rgb(0, 0, 0);")
		vboxexp.addWidget(label)

		if viewmode == 0:
			hboxbuttonsexp = QtGui.QHBoxLayout()
			vboxexp.addLayout(hboxbuttonsexp)
			hboxbuttonsexp.setAlignment(QtCore.Qt.AlignLeft)
			upicon = QtGui.QIcon()
			upicon.addPixmap(QtGui.QPixmap(":/common/icon/up2.png"))
			reloadicon = QtGui.QIcon()
			reloadicon.addPixmap(QtGui.QPixmap(":/common/icon/refresh.png"))

			viewicons = QtGui.QIcon()
			viewicons.addPixmap(QtGui.QPixmap(":/common/icon/list-icon.png"))
			viewlist = QtGui.QIcon()
			viewlist.addPixmap(QtGui.QPixmap(":/common/icon/list.png"))

			reloadbutton = QtGui.QPushButton(reloadicon, "", self)
			self.connect(reloadbutton, QtCore.SIGNAL("clicked()"), self.reload_dir)
			reloadbutton.setMinimumSize(32, 32)
			reloadbutton.setToolTip("Refrescar")

			viewiconsbutton = QtGui.QPushButton(viewicons, "", self)
			self.connect(viewiconsbutton, QtCore.SIGNAL("clicked()"), self.set_icons_view)
			viewiconsbutton.setMinimumSize(32, 32)
			viewiconsbutton.setToolTip("Ver archivos en modo iconos")
			viewlistbutton = QtGui.QPushButton(viewlist, "", self)
			self.connect(viewlistbutton, QtCore.SIGNAL("clicked()"), self.set_list_view)
			viewlistbutton.setMinimumSize(32, 32)
			viewlistbutton.setToolTip("Ver archivos en modo lista")

			hboxbuttonsexp.addWidget(reloadbutton)

			hboxbuttonsexp.addWidget(viewiconsbutton)
			hboxbuttonsexp.addWidget(viewlistbutton)

		self.filespace = QtGui.QListWidget()
		self.filespace.setMovement(0)
		self.filespace.setViewportMargins(5, 5, 5, 5)
		os.system('ls '+self.rutaProfesor+' > ~/Descargas/archivosProfesor.txt')
		with open('/home/usuario/Descargas/archivosProfesor.txt') as f:
			for linea in f:
				self.filespace.addItem(linea)

		if viewmode == 0:
			self.set_icons_view()
		else:
			self.set_list_view()
		self.filespace.setSortingEnabled(True)
		vboxexp.addWidget(self.filespace)

		if viewmode == 0:
			hboxbuttons = QtGui.QHBoxLayout()
			downloadicon = QtGui.QIcon()
			downloadicon.addPixmap(QtGui.QPixmap(":/common/icon/download.png"))
			downloadbutton = QtGui.QPushButton(downloadicon, "Descargar todos los archivos compartidos por el profesor", self)
			downloadbutton.setStyleSheet("font: bold 14px; color: black; background-color: rgb(190, 190, 190);")
			self.connect(downloadbutton, QtCore.SIGNAL("clicked()"), self.descargar_carpeta_profesor)
			downloadbutton.setMinimumSize(120, 50)
			hboxbuttons.addWidget(downloadbutton)
			vboxexp.addLayout(hboxbuttons)

		resp = '0'
		if resp == '-1':
			QtGui.QMessageBox.warning(self, u"Atención", u"<br>Servicio de archivos compartidos desactivado. Vuelve a intentarlo.", u"Cerrar")
		else:
			if viewmode == 0:
				self.current_dir = self.remotedir2
				self.level = 5
			else:
				self.current_dir = userdir
				self.level = 6

	##\fn fill_explorer(self)
	# \fn Load webdav directory based in self.current_dir and self.level
	def descargar_carpeta_profesor(self):
		os.system('ls ' + self.rutaProfesor)
		os.system('cp -nrv ' + self.rutaProfesor + '/* /home/usuario/Descargas')
		os.system('xdg-open /home/usuario/Descargas')



	##\fn reload_dir(self)
	# \brief Reload current directory
	#Actualizar directorio actual
	def reload_dir(self):
		os.system('ls ' + self.rutaProfesor + ' > ~/Descargas/archivosProfesor.txt')
		self.filespace.clear()
		with open('/home/usuario/Descargas/archivosProfesor.txt') as f:
			for linea in f:
				self.filespace.addItem(linea)


	##\fn goto_init(self)
	# \brief Go to initial webdav directory
	#Ir al directorio inicial
	def goto_init(self):
		self.current_dir = self.remotedir2
		self.level = 5
		self.fill_explorer()

	##\fn up_level(self)
	# \brief Up a one level dir on webdav explorer
	#Subir unn nivel del directorio
	def up_level(self):
		if self.level == 5:
			return
		string = self.current_dir.split('/')
		self.current_dir = ''
		for i in range(1,len(string)-1):
			self.current_dir = self.current_dir + '/' + string[i]
		self.level = self.level - 1
		self.fill_explorer()



	def descargar_carpeta_profesor(self):
		os.system('ls ' + self.rutaProfesor)
		os.system('cp -nrv ' + self.rutaProfesor + '/* /home/usuario/Descargas')
		os.system('xdg-open /home/usuario/Descargas')



	def mime_type(self, name):
		icon = QtGui.QIcon()
		ext = name.split('.')[-1]
		ruta="/usr/share/icons/GeduIcons/mimetypes/scalable/"
		icon.setThemeName(ruta)
		if ext == 'html' or ext == 'htm':
			return icon.fromTheme("libreoffice-oasis-web-template", QtGui.QIcon(ruta+"/libreoffice-oasis-web-template.svg"))
		elif ext == 'png' or ext == 'jpg' or ext == 'jpeg' or ext == 'gif' or ext == 'bmp':
			return icon.fromTheme("application-images", QtGui.QIcon(ruta+"/application-images.svg"))
		elif ext == 'mp3' or ext == 'ogg' or ext == 'wma' or ext == 'mp4' or ext == 'cda' or ext == 'aac' or ext == 'wav':
			return icon.fromTheme("audio-x-adpcm", QtGui.QIcon(ruta+"/audio-x-adpcm.svg"))
		elif ext == 'ods':
			return icon.fromTheme("libreoffice-oasis-spreadsheet", QtGui.QIcon(ruta+"/libreoffice-oasis-spreadsheet.svg"))
		elif ext == 'odp':
			return icon.fromTheme("libreoffice-oasis-presentation", QtGui.QIcon(ruta+"/libreoffice-oasis-presentation.svg"))
		elif ext == 'odt':
			return icon.fromTheme("libreoffice-oasis-text", QtGui.QIcon(ruta+"/libreoffice-oasis-text.svg"))
		elif ext == 'pdf':
			return icon.fromTheme("application-pdf", QtGui.QIcon(ruta+"/application-pdf.svg"))
		elif ext == 'odb':
			return icon.fromTheme("libreoffice-oasis-database", QtGui.QIcon(ruta+"/libreoffice-oasis-database.svg"))
		elif ext == 'doc':
			return icon.fromTheme("application-msword", QtGui.QIcon(ruta+"/application-msword.svg"))
		elif ext == 'txt':
			return icon.fromTheme("libreoffice-oasis-master-document", QtGui.QIcon(ruta+"/libreoffice-oasis-master-document.svg"))
		elif ext == 'odg':
			return icon.fromTheme("libreoffice-oasis-drawing", QtGui.QIcon(ruta+"/libreoffice-oasis-drawing.svg"))
		elif ext == 'avi' or ext == 'mpg' or ext == 'mpeg' or ext == 'mov' or ext == 'flv' or ext == 'wmv' or ext == 'mkv':
			return icon.fromTheme("video-x-generic", QtGui.QIcon(ruta+"/video-x-generic.svg"))
		elif ext == 'zip' or ext == 'gz' or ext == 'bz' or ext == 'bz2' or ext == 'rar' or ext == 'deb':
			return icon.fromTheme("application-x-ace", QtGui.QIcon(ruta+"/application-x-ace.svg"))
		else:
			return icon.fromTheme("text-x-preview", QtGui.QIcon(ruta+"/text-x-preview.svg"))

	def set_icons_view(self):
		self.filespace.setViewMode(1)
		self.filespace.setGridSize(QtCore.QSize(120, 58))

	def set_list_view(self):
		self.filespace.setViewMode(0)
		self.filespace.setGridSize(QtCore.QSize(120, 30))

##\class explorer_element
# \brief
class explorerItem(QtGui.QListWidgetItem):
	def set_type(self, item_type):
		self.item_type = item_type

