#!/usr/bin/env python
# -*- coding: UTF-8 -*-


import os
import sys
import time
import threading
import subprocess
try:    
    import gtk
    import gobject
except ImportError:
    sys.stderr.write("Por favor, instala las bibliotecas GTK 2.0 en tu sistema.\n")
    sys.exit(1)
gobject.threads_init()
# 0 is infinite loop
TIME = 0

##\class stream_Cliente
# \brief Clase del modulo controlStreaming para la recepcion de audios y videos
class stream_Cliente:

    ## \fn stream_handlers_cliente(self)
    # \brief Handler del cliente de streaming.
    # \return self.stream_handlers, los handlers del cliente
    def stream_handlers_cliente(self):
        self.sc_handlers = {
            "RECIBIR_EMISION": self.recibir_emision,
            "KILL_VLC":self.kill_vlc,
        }
        return self.sc_handlers

    ## \fn recibir_emision(self, ip_servidor)
    # \brief Se encarga de recibir la ip del servidor y lanzar la herramienta vlc para recibir el streaming.
    # \param ip_servidor, la ip donde estara a la escucha
    def recibir_emision(self, ip_servidor):
        cadena = "vlc '--quiet' '--network-caching=100' '-f' 'rtp://@%s:8080'" % ip_servidor
        thread = threading.Thread(target=self.ejecuta_streaming_cliente, args=(cadena,))
        root_window = gtk.gdk.get_default_root_window()
        self._lock_keyboard(root_window)
        self._lock_mouse(root_window)

        thread.start()

    ## \fn ejecuta_streaming_cliente(self, cadena)
    # \brief Ejecuta la sentencia pasada por el hilo para la recepcion del streaming.
    # \param cadena, la sentencia a ejecutar
    def ejecuta_streaming_cliente(self, cadena):
        os.system(str(cadena))

    def _lock_keyboard(self, root_window):
        gtk.gdk.keyboard_grab(root_window, False, TIME)

    def _lock_mouse(self,root_window):
        event_mask = gtk.gdk.BUTTON_PRESS_MASK
        time = gtk.gdk.CURRENT_TIME

        # Get the default root window if root_window is not provided

        cursor = gtk.gdk.Cursor(gtk.gdk.BLANK_CURSOR)
        try:
            gtk.gdk.pointer_grab(root_window, False, event_mask, None, None, TIME)
        except Exception as e:
            print("Error while grabbing mouse:", e)

    ## \fn kill_vlc(self)
    # \brief Cuando el servidor termina la emision lanza un mensaje para que el cliente mate el proceso.
    def kill_vlc(self):
        gtk.gdk.keyboard_ungrab(gtk.gdk.CURRENT_TIME)
        gtk.gdk.pointer_ungrab(gtk.gdk.CURRENT_TIME)
        os.system('pkill -9 vlc')
 
